//*******************************************************************************************
//Controllo del Movimento
//*******************************************************************************************

void motionControl ()
{	int mySpeed;
	
	//in funzione della distanza decido la velocit	
	if (distance > 100 && distanceLeft > 100 && distanceRight > 100 )
			mySpeed = 4;
		else
		if (distance > 80 && distanceLeft > 80 && distanceRight > 80 )
				mySpeed = 3;
			else
			if (distance > 30 && distanceLeft > 30 && distanceRight > 30 )
				mySpeed = 2;
			else
				mySpeed = 1;
	

	//Controllo se il Robot si  incastrato
	if ((LeftRoadBlock+FrontRoadBlock+RightRoadBlock)>1)
	{	
		Halt ();
		Backwards(speedTable[mySpeed]); 
		Delay (60);
		turnRight (speedTable[mySpeed]);
		Delay (30);
		
		LeftRoadBlock = 0;	//azzero i flag che segnalano l'avvenuto incastro
		FrontRoadBlock = 0;	
		RightRoadBlock = 0;	
		
		leftCounter = 0;	// contatori per verificare da quanto le distanze non variano
		rightCounter = 0;
		frontCounter = 0;	
	}
	
	//Controllo se ho urtato qualche ostacolo a sinistra			
	if (LeftCrash)
		{
			Backwards(speedTable[mySpeed]); 
			Delay (20);
			turnRight (speedTable[mySpeed]);
			Delay (10);
			LeftCrash = 0;				
		}
	
	
	//Controllo se ho urtato qualche ostacolo a destra			
	if (RightCrash)
		{
			Backwards(speedTable[mySpeed]); 
			Delay (20);
			turnLeft (speedTable[mySpeed]);
			Delay (10);
			RightCrash = 0;				
		}
		

	//Controllo eventuali ostacoli rilevati con gli ultrasuoni
					
	if (distance < 12)
			turnRight (speedTable[mySpeed]);
		else 
			if (distanceLeft < 15)
				turnRight (speedTable[mySpeed]);
			else 
				if (distanceRight < 15)
					turnLeft (speedTable[mySpeed]);
				else 
					Forward (speedTable[mySpeed]);	
					
		
	//Controllo se accendere i LED
	
	if (Night ==1)			
		PORTE = 0x01;			
	else	
		PORTE = 0x00;
			
}
