//*******************************************************************************************
//blocco i motori
//*******************************************************************************************

void Halt ()
{	
	PORTBbits.RB2 = 0;	//spengo i led di direzione
	PORTBbits.RB3 = 0;
	
	ClosePWM1 ();
	PORTCbits.RC2 = 0;	
}

//*******************************************************************************************
//funzione per andare avanti
//*******************************************************************************************

void Forward (int speed)
{		
	PORTBbits.RB2 = 1;
	PORTBbits.RB3 = 0;
	
	OpenPWM1(Period);	// apro il PWM
	SetDCPWM1 (speed);	
}

//*******************************************************************************************
//funzione per andare indietro
//*******************************************************************************************

void Backwards (int speed)
{		
	PORTBbits.RB2 = 0;
	PORTBbits.RB3 = 1;
	
	OpenPWM1(Period);	// apro il PWM
	SetDCPWM1 (speed);	
}

//*******************************************************************************************
//funzione per girare a sinistra 
//*******************************************************************************************

void turnLeft (int speed)
{	
	PORTBbits.RB2 = 0;
	PORTBbits.RB3 = 0;
	
	OpenPWM1(Period);	// apro il PWM
	SetDCPWM1 (speed);	
}

//*******************************************************************************************
//funzione per girare a destra
//*******************************************************************************************

void turnRight (int speed)
{		
	PORTBbits.RB2 = 1;
	PORTBbits.RB3 = 1;
	
	OpenPWM1(Period);	// apro il PWM
	SetDCPWM1 (speed);
	
}
